function OnSceneLoad(screen)
    LoadData(screen)
    DefaultOnSceneLoad('data/Scenes/24_Hold_Floor_HO.lua', 'hidden_object', 'data/Scenes/24_Hold_Main.lua')
    
    AddTask(CreateTask('COMBINATION_PLIERS',  '',      'CombinationPliers'))
    AddTask(CreateTask('LOCK',                'LOCKS', 'Lock1', 'Lock2', 'Lock3'))
    
    AddRandomTasks( CreateTask('BAROMETER',      '', 'Barometer'),
                    CreateTask('BILLIARD_BALL',  '', 'BilliardBall'),
                    CreateTask('BOOT',           '', 'Boot'),
                    CreateTask('BOW',            '', 'Bow'),
                    CreateTask('BRUSH',          '', 'Brush'),
                    CreateTask('BUTTONS',        '', 'Buttons'),
                    CreateTask('CARD',           '', 'Card'),
                    CreateTask('COMB',           '', 'Comb'),
                    CreateTask('DOG',            '', 'Dog'),
                    CreateTask('DRAGONFLY',      '', 'Dragonfly'),
                    CreateTask('FAN',            '', 'Fan'),
                    CreateTask('FISH',           '', 'Fish'),
                    CreateTask('FORK',           '', 'Fork'),
                    CreateTask('GARLIC',         '', 'Garlic'),
                    CreateTask('GLOVES',         '', 'Gloves'),
                    CreateTask('GRATER',         '', 'Grater'),
                    CreateTask('HANGER',         '', 'Hanger'),
                    CreateTask('HAT',            '', 'Hat'),
                    CreateTask('HAIRBAND',       '', 'Hoop'),
                    CreateTask('INKPOT',         '', 'Inkpot'),
                    CreateTask('KNIFE',          'KNIFES', 'Knife', 'Dagger'),
                    CreateTask('LEAF',           '', 'Leaf'),
                    CreateTask('LIPSTICK',       '', 'Lipstick'),
                    CreateTask('MASK',           '', 'Mask'),
                    CreateTask('PALA',           '', 'Pala'),
                    CreateTask('PENDANT',        '', 'Pendent'),
                    CreateTask('SEXTANT',        '', 'Sextant'),
                    CreateTask('SHIP',           '', 'Ship'),
                    CreateTask('SHOE',           '', 'Shoe'),
                    CreateTask('SILHOUETTE',     '', 'Silhouette'),
                    CreateTask('STALK_OF_WHEAT', '', 'Spikelet'),
                    CreateTask('STAR',           '', 'Star'),
                    CreateTask('STATUETTE',      '', 'Statuette'),
                    CreateTask('WALKING_STICK',  '', 'Stick'),
                    CreateTask('VIAL',           '', 'Vial'));
    
    RegisterToolFindInfo('24_combination_pliers');
end

function OnSceneFree(screen)
    DefaultOnSceneFree()
    FreeData(screen)
end

function OnUpdate(dt)
    DefaultOnUpdate(dt)
end

function OnAllItemsFound()
    DefaultOnAllItemsFound()
end

function OnLose()
    DefaultOnLose()
end

function OnExit()
    DefaultOnExit()
end

function OnClose()
    DefaultOnClose()
end

function OnObjectMouseEnter(object)
    DefaultOnObjectMouseEnter(object)
end

function OnObjectMouseLeave(object)
    DefaultOnObjectMouseLeave(object)
end

function OnObjectMouseDown(object)
    local is_wrong_click = not DefaultOnObjectMouseDown(object)
    local obj_name = object:GetName()
    local pf = play_field

    DefaultOnObjectMouseDownProcessed(is_wrong_click);
end

function OnObjectMouseUp(object)
    DefaultOnObjectMouseUp(object)
end

function OnObjectFound(object)
    DefaultOnObjectFound(object)
end

function OnToolFound(tool)
    DefaultOnToolFound(tool)
end

function OnToolApply(tool, object)
    DefaultOnToolApply(tool, object)
end

function OnObjectReachPanel(object)
    DefaultOnObjectReachPanel(object)
end

function OnButtonPress(title)
    DefaultOnButtonPress(title)
end

function OnMouseMove(previous_pos, current_pos)
    DefaultOnMouseMove(previous_pos, current_pos)
end

function OnSetTool(tool)
    DefaultOnSetTool(tool)
end

function LevelLoaded(level)
end

function OnSceneDestroy(playfield)
    DefaultOnSceneDestroy(playfield)
end

--------------------------------------------------------------------------------
-- CLEAR_ON_SAVE_BEGIN
-- Do not edit code listed below (generated by the editor on each save)
function LoadData(screen)
	local anim = CreateAnimation('data/Texture/Scenes/24_Hold/Zone_HO_floor/Layers/background.jpg',0,0,1024,768,1,0)
	anim:SetHotSpot(512,384)
	anim:SetBlendMode(2)
	anim:SetColor('0xFFFFFFFF')
	screen:CreateObject('background',anim,512,384,100,0,1,1)
	local anim = CreateAnimation('data/Texture/Scenes/24_Hold/Zone_HO_floor/Items/Barometer.png',0,0,95,90,1,0)
	anim:SetHotSpot(47,45)
	anim:SetBlendMode(2)
	anim:SetColor('0xFFFFFFFF')
	screen:CreateObject('Barometer',anim,882,40,101,0,1,1)
	local anim = CreateAnimation('data/Texture/Scenes/24_Hold/Zone_HO_floor/Items/BilliardBall.png',0,0,62,53,1,0)
	anim:SetHotSpot(31,26)
	anim:SetBlendMode(2)
	anim:SetColor('0xFFFFFFFF')
	screen:CreateObject('BilliardBall',anim,386,356,101,0,1,1)
	local anim = CreateAnimation('data/Texture/Scenes/24_Hold/Zone_HO_floor/Items/Boot.png',0,0,143,129,1,0)
	anim:SetHotSpot(71,64)
	anim:SetBlendMode(2)
	anim:SetColor('0xFFFFFFFF')
	screen:CreateObject('Boot',anim,595,405,102,0,1,1)
	local anim = CreateAnimation('data/Texture/Scenes/24_Hold/Zone_HO_floor/Items/Bow.png',0,0,66,71,1,0)
	anim:SetHotSpot(33,35)
	anim:SetBlendMode(2)
	anim:SetColor('0xFFFFFFFF')
	screen:CreateObject('Bow',anim,165,408,101,0,1,1)
	local anim = CreateAnimation('data/Texture/Scenes/24_Hold/Zone_HO_floor/Items/Brush.png',0,0,155,69,1,0)
	anim:SetHotSpot(77,34)
	anim:SetBlendMode(2)
	anim:SetColor('0xFFFFFFFF')
	screen:CreateObject('Brush',anim,235,187,101,0,1,1)
	local anim = CreateAnimation('data/Texture/Scenes/24_Hold/Zone_HO_floor/Items/Buttons.png',0,0,56,55,1,0)
	anim:SetHotSpot(28,27)
	anim:SetBlendMode(2)
	anim:SetColor('0xFFFFFFFF')
	screen:CreateObject('Buttons',anim,984,623,101,0,1,1)
	local anim = CreateAnimation('data/Texture/Scenes/24_Hold/Zone_HO_floor/Items/Card.png',0,0,64,65,1,0)
	anim:SetHotSpot(32,32)
	anim:SetBlendMode(2)
	anim:SetColor('0xFFFFFFFF')
	screen:CreateObject('Card',anim,79,319,101,0,1,1)
	local anim = CreateAnimation('data/Texture/Scenes/24_Hold/Zone_HO_floor/Items/Comb.png',0,0,67,101,1,0)
	anim:SetHotSpot(33,50)
	anim:SetBlendMode(2)
	anim:SetColor('0xFFFFFFFF')
	screen:CreateObject('Comb',anim,29,497,102,0,1,1)
	local anim = CreateAnimation('data/Texture/Scenes/24_Hold/Zone_HO_floor/Items/CombinationPliers.png',0,0,74,128,1,0)
	anim:SetHotSpot(37,64)
	anim:SetBlendMode(2)
	anim:SetColor('0xFFFFFFFF')
	screen:CreateObject('CombinationPliers',anim,590,328,101,0,1,1)
	local anim = CreateAnimation('data/Texture/Scenes/24_Hold/Zone_HO_floor/Items/Dagger.png',0,0,154,97,1,0)
	anim:SetHotSpot(77,48)
	anim:SetBlendMode(2)
	anim:SetColor('0xFFFFFFFF')
	screen:CreateObject('Dagger',anim,882,282,105,0,1,1)
	local anim = CreateAnimation('data/Texture/Scenes/24_Hold/Zone_HO_floor/Items/Dog.png',0,0,123,106,1,0)
	anim:SetHotSpot(61,53)
	anim:SetBlendMode(2)
	anim:SetColor('0xFFFFFFFF')
	screen:CreateObject('Dog',anim,788,285,106,0,1,1)
	local anim = CreateAnimation('data/Texture/Scenes/24_Hold/Zone_HO_floor/Items/Dragonfly.png',0,0,84,63,1,0)
	anim:SetHotSpot(42,31)
	anim:SetBlendMode(2)
	anim:SetColor('0xFFFFFFFF')
	screen:CreateObject('Dragonfly',anim,46,403,101,0,1,1)
	local anim = CreateAnimation('data/Texture/Scenes/24_Hold/Zone_HO_floor/Items/Fan.png',0,0,148,140,1,0)
	anim:SetHotSpot(74,70)
	anim:SetBlendMode(2)
	anim:SetColor('0xFFFFFFFF')
	screen:CreateObject('Fan',anim,954,290,103,0,1,1)
	local anim = CreateAnimation('data/Texture/Scenes/24_Hold/Zone_HO_floor/Items/Fish.png',0,0,143,113,1,0)
	anim:SetHotSpot(71,56)
	anim:SetBlendMode(2)
	anim:SetColor('0xFFFFFFFF')
	screen:CreateObject('Fish',anim,729,602,101,0,1,1)
	local anim = CreateAnimation('data/Texture/Scenes/24_Hold/Zone_HO_floor/Items/Fork.png',0,0,69,150,1,0)
	anim:SetHotSpot(34,75)
	anim:SetBlendMode(2)
	anim:SetColor('0xFFFFFFFF')
	screen:CreateObject('Fork',anim,406,394,102,0,1,1)
	local anim = CreateAnimation('data/Texture/Scenes/24_Hold/Zone_HO_floor/Items/Garlic.png',0,0,90,53,1,0)
	anim:SetHotSpot(45,26)
	anim:SetBlendMode(2)
	anim:SetColor('0xFFFFFFFF')
	screen:CreateObject('Garlic',anim,220,634,102,0,1,1)
	local anim = CreateAnimation('data/Texture/Scenes/24_Hold/Zone_HO_floor/Items/Gloves.png',0,0,125,180,1,0)
	anim:SetHotSpot(62,90)
	anim:SetBlendMode(2)
	anim:SetColor('0xFFFFFFFF')
	screen:CreateObject('Gloves',anim,70,546,101,0,1,1)
	local anim = CreateAnimation('data/Texture/Scenes/24_Hold/Zone_HO_floor/Items/Grater.png',0,0,102,87,1,0)
	anim:SetHotSpot(51,43)
	anim:SetBlendMode(2)
	anim:SetColor('0xFFFFFFFF')
	screen:CreateObject('Grater',anim,619,540,101,0,1,1)
	local anim = CreateAnimation('data/Texture/Scenes/24_Hold/Zone_HO_floor/Items/Hanger.png',0,0,217,114,1,0)
	anim:SetHotSpot(108,57)
	anim:SetBlendMode(2)
	anim:SetColor('0xFFFFFFFF')
	screen:CreateObject('Hanger',anim,156,303,103,0,1,1)
	local anim = CreateAnimation('data/Texture/Scenes/24_Hold/Zone_HO_floor/Items/Hat.png',0,0,153,100,1,0)
	anim:SetHotSpot(76,50)
	anim:SetBlendMode(2)
	anim:SetColor('0xFFFFFFFF')
	screen:CreateObject('Hat',anim,481,202,101,0,1,1)
	local anim = CreateAnimation('data/Texture/Scenes/24_Hold/Zone_HO_floor/Items/Hoop.png',0,0,126,70,1,0)
	anim:SetHotSpot(63,35)
	anim:SetBlendMode(2)
	anim:SetColor('0xFFFFFFFF')
	screen:CreateObject('Hoop',anim,116,343,105,0,1,1)
	local anim = CreateAnimation('data/Texture/Scenes/24_Hold/Zone_HO_floor/Items/Inkpot.png',0,0,77,63,1,0)
	anim:SetHotSpot(38,31)
	anim:SetBlendMode(2)
	anim:SetColor('0xFFFFFFFF')
	screen:CreateObject('Inkpot',anim,635,173,102,0,1,1)
	local anim = CreateAnimation('data/Texture/Scenes/24_Hold/Zone_HO_floor/Items/Knife.png',0,0,128,36,1,0)
	anim:SetHotSpot(64,18)
	anim:SetBlendMode(2)
	anim:SetColor('0xFFFFFFFF')
	screen:CreateObject('Knife',anim,618,468,101,0,1,1)
	local anim = CreateAnimation('data/Texture/Scenes/24_Hold/Zone_HO_floor/Items/Leaf.png',0,0,55,55,1,0)
	anim:SetHotSpot(27,27)
	anim:SetBlendMode(2)
	anim:SetColor('0xFFFFFFFF')
	screen:CreateObject('Leaf',anim,457,309,101,0,1,1)
	local anim = CreateAnimation('data/Texture/Scenes/24_Hold/Zone_HO_floor/Items/Lipstick.png',0,0,80,71,1,0)
	anim:SetHotSpot(40,35)
	anim:SetBlendMode(2)
	anim:SetColor('0xFFFFFFFF')
	screen:CreateObject('Lipstick',anim,445,625,101,0,1,1)
	local anim = CreateAnimation('data/Texture/Scenes/24_Hold/Zone_HO_floor/Items/Lock1.png',0,0,96,81,1,0)
	anim:SetHotSpot(48,40)
	anim:SetBlendMode(2)
	anim:SetColor('0xFFFFFFFF')
	screen:CreateObject('Lock1',anim,235,587,101,0,1,1)
	local anim = CreateAnimation('data/Texture/Scenes/24_Hold/Zone_HO_floor/Items/Lock2.png',0,0,120,73,1,0)
	anim:SetHotSpot(60,36)
	anim:SetBlendMode(2)
	anim:SetColor('0xFFFFFFFF')
	screen:CreateObject('Lock2',anim,712,505,101,0,1,1)
	local anim = CreateAnimation('data/Texture/Scenes/24_Hold/Zone_HO_floor/Items/Lock3.png',0,0,47,43,1,0)
	anim:SetHotSpot(23,21)
	anim:SetBlendMode(2)
	anim:SetColor('0xFFFFFFFF')
	screen:CreateObject('Lock3',anim,953,60,101,0,1,1)
	local anim = CreateAnimation('data/Texture/Scenes/24_Hold/Zone_HO_floor/Items/Mask.png',0,0,105,179,1,0)
	anim:SetHotSpot(52,89)
	anim:SetBlendMode(2)
	anim:SetColor('0xFFFFFFFF')
	screen:CreateObject('Mask',anim,118,134,101,0,1,1)
	local anim = CreateAnimation('data/Texture/Scenes/24_Hold/Zone_HO_floor/Items/Pala.png',0,0,102,146,1,0)
	anim:SetHotSpot(51,73)
	anim:SetBlendMode(2)
	anim:SetColor('0xFFFFFFFF')
	screen:CreateObject('Pala',anim,701,371,101,0,1,1)
	local anim = CreateAnimation('data/Texture/Scenes/24_Hold/Zone_HO_floor/Items/Pendent.png',0,0,44,117,1,0)
	anim:SetHotSpot(22,58)
	anim:SetBlendMode(2)
	anim:SetColor('0xFFFFFFFF')
	screen:CreateObject('Pendent',anim,894,150,103,0,1,1)
	local anim = CreateAnimation('data/Texture/Scenes/24_Hold/Zone_HO_floor/Items/Sextant.png',0,0,151,162,1,0)
	anim:SetHotSpot(75,81)
	anim:SetBlendMode(2)
	anim:SetColor('0xFFFFFFFF')
	screen:CreateObject('Sextant',anim,745,185,103,0,1,1)
	local anim = CreateAnimation('data/Texture/Scenes/24_Hold/Zone_HO_floor/Items/Ship.png',0,0,77,80,1,0)
	anim:SetHotSpot(38,40)
	anim:SetBlendMode(2)
	anim:SetColor('0xFFFFFFFF')
	screen:CreateObject('Ship',anim,262,54,101,0,1,1)
	local anim = CreateAnimation('data/Texture/Scenes/24_Hold/Zone_HO_floor/Items/Shoe.png',0,0,59,129,1,0)
	anim:SetHotSpot(29,64)
	anim:SetBlendMode(2)
	anim:SetColor('0xFFFFFFFF')
	screen:CreateObject('Shoe',anim,357,191,101,0,1,1)
	local anim = CreateAnimation('data/Texture/Scenes/24_Hold/Zone_HO_floor/Items/Silhouette.png',0,0,29,71,1,0)
	anim:SetHotSpot(14,35)
	anim:SetBlendMode(2)
	anim:SetColor('0xFFFFFFFF')
	screen:CreateObject('Silhouette',anim,693,93,101,0,1,1)
	local anim = CreateAnimation('data/Texture/Scenes/24_Hold/Zone_HO_floor/Items/Spikelet.png',0,0,269,87,1,0)
	anim:SetHotSpot(134,43)
	anim:SetBlendMode(2)
	anim:SetColor('0xFFFFFFFF')
	screen:CreateObject('Spikelet',anim,875,540,101,0,1,1)
	local anim = CreateAnimation('data/Texture/Scenes/24_Hold/Zone_HO_floor/Items/Star.png',0,0,113,125,1,0)
	anim:SetHotSpot(56,62)
	anim:SetBlendMode(2)
	anim:SetColor('0xFFFFFFFF')
	screen:CreateObject('Star',anim,538,78,101,0,1,1)
	local anim = CreateAnimation('data/Texture/Scenes/24_Hold/Zone_HO_floor/Items/Statuette.png',0,0,95,152,1,0)
	anim:SetHotSpot(47,76)
	anim:SetBlendMode(2)
	anim:SetColor('0xFFFFFFFF')
	screen:CreateObject('Statuette',anim,306,596,102,0,1,1)
	local anim = CreateAnimation('data/Texture/Scenes/24_Hold/Zone_HO_floor/Items/Stick.png',0,0,342,124,1,0)
	anim:SetHotSpot(171,62)
	anim:SetBlendMode(2)
	anim:SetColor('0xFFFFFFFF')
	screen:CreateObject('Stick',anim,807,181,101,0,1,1)
	local anim = CreateAnimation('data/Texture/Scenes/24_Hold/Zone_HO_floor/Items/Vial.png',0,0,82,109,1,0)
	anim:SetHotSpot(41,54)
	anim:SetBlendMode(2)
	anim:SetColor('0xFFFFFFFF')
	screen:CreateObject('Vial',anim,457,440,101,0,1,1)
	local anim = CreateAnimation('data/Texture/Scenes/24_Hold/Zone_HO_floor/Layers/BG_Flakon.png',0,0,31,58,1,0)
	anim:SetHotSpot(15,29)
	anim:SetBlendMode(2)
	anim:SetColor('0xFFFFFFFF')
	screen:CreateObject('BG_Flakon',anim,424,451,102,0,1,1)
	local anim = CreateAnimation('data/Texture/Scenes/24_Hold/Zone_HO_floor/Layers/BG_Kolosok.png',0,0,123,39,1,0)
	anim:SetHotSpot(61,19)
	anim:SetBlendMode(2)
	anim:SetColor('0xFFFFFFFF')
	screen:CreateObject('BG_Kolosok',anim,880,518,102,0,1,1)
	local anim = CreateAnimation('data/Texture/Scenes/24_Hold/Zone_HO_floor/Layers/BG_Listok.png',0,0,52,28,1,0)
	anim:SetHotSpot(26,14)
	anim:SetBlendMode(2)
	anim:SetColor('0xFFFFFFFF')
	screen:CreateObject('BG_Listok',anim,467,294,102,0,1,1)
	local anim = CreateAnimation('data/Texture/Scenes/24_Hold/Zone_HO_floor/Layers/BG_Nozhik.png',0,0,48,22,1,0)
	anim:SetHotSpot(24,11)
	anim:SetBlendMode(2)
	anim:SetColor('0xFFFFFFFF')
	screen:CreateObject('BG_Nozhik',anim,571,481,102,0,1,1)
	local anim = CreateAnimation('data/Texture/Scenes/24_Hold/Zone_HO_floor/Layers/BG_Sharik_bilyardny.png',0,0,47,37,1,0)
	anim:SetHotSpot(23,18)
	anim:SetBlendMode(2)
	anim:SetColor('0xFFFFFFFF')
	screen:CreateObject('BG_Sharik_bilyardny',anim,370,370,102,0,1,1)
	local anim = CreateAnimation('data/Texture/Scenes/24_Hold/Zone_HO_floor/Layers/BG_Strekoza.png',0,0,40,57,1,0)
	anim:SetHotSpot(20,28)
	anim:SetBlendMode(2)
	anim:SetColor('0xFFFFFFFF')
	screen:CreateObject('BG_Strekoza',anim,74,408,102,0,1,1)
	local anim = CreateAnimation('data/Texture/Scenes/24_Hold/Zone_HO_floor/Layers/BG_Trost.png',0,0,251,104,1,0)
	anim:SetHotSpot(125,52)
	anim:SetBlendMode(2)
	anim:SetColor('0xFFFFFFFF')
	screen:CreateObject('BG_Trost',anim,886,210,102,0,1,1)
	local anim = CreateAnimation('data/Texture/Scenes/24_Hold/Zone_HO_floor/Layers/BG_Veer.png',0,0,187,163,1,0)
	anim:SetHotSpot(93,81)
	anim:SetBlendMode(2)
	anim:SetColor('0xFFFFFFFF')
	screen:CreateObject('BG_Veer',anim,935,319,104,0,1,1)
	local anim = CreateAnimation('data/Texture/Scenes/24_Hold/Zone_HO_floor/Layers/BG_Veshalka_Karta.png',0,0,116,57,1,0)
	anim:SetHotSpot(58,28)
	anim:SetBlendMode(2)
	anim:SetColor('0xFFFFFFFF')
	screen:CreateObject('BG_Veshalka_Karta',anim,94,338,104,0,1,1)
	local anim = CreateAnimation('data/Texture/Scenes/24_Hold/Zone_HO_floor/Layers/BG_Vilka.png',0,0,36,99,1,0)
	anim:SetHotSpot(18,49)
	anim:SetBlendMode(2)
	anim:SetColor('0xFFFFFFFF')
	screen:CreateObject('BG_Vilka',anim,382,429,103,0,1,1)
	local anim = CreateAnimation('data/Texture/Scenes/24_Hold/Zone_HO_floor/Layers/BG_Zamok2.png',0,0,43,84,1,0)
	anim:SetHotSpot(21,42)
	anim:SetBlendMode(2)
	anim:SetColor('0xFFFFFFFF')
	screen:CreateObject('BG_Zamok2',anim,756,505,102,0,1,1)
	local anim = CreateAnimation('data/Texture/Scenes/24_Hold/Zone_HO_floor/Layers/BG_Tuflya.png',0,0,19,38,1,0)
	anim:SetHotSpot(9,19)
	anim:SetBlendMode(2)
	anim:SetColor('0xFFFFFFFF')
	screen:CreateObject('BG_Tuflya',anim,370,183,103,0,1,1)
end

function FreeData(screen)
end
-- CLEAR_ON_SAVE_END
